Codeforces Round #333 (Div. 2) C. The Two Routes (最短路)

网友投稿 253 2022-11-29

Codeforces Round #333 (Div. 2) C. The Two Routes (最短路)

C. The Two Routes

time limit per test

memory limit per test

input

output

In Absurdistan, there are n towns (numbered 1 through n) and m bidirectional railways. There is also an absurdly simple road network — for each pair of different towns x and y, there is a bidirectional road between towns x and y if and only if

A train and a bus leave town 1 at the same time. They both have the same destination, town n, and don't make any stops on the way (but they can wait in town n). The train can move only along railways and the bus can move only along roads.

You've been asked to plan out routes for the vehicles; each route can use any road/railway multiple times. One of the most important aspects to consider is safety — in order to avoid accidents at railway crossings, the train and the bus must not arrive at the same town (except town n) simultaneously.

Under these constraints, what is the minimum number of hours needed for both vehicles to reach town n (the maximum of arrival times of the bus and the train)? Note, that bus and train are not required to arrive to the town n

Input

The first line of the input contains two integers n and m (2 ≤ n ≤ 400, 0 ≤ m ≤ n(n - 1) / 2) — the number of towns and the number of railways respectively.

Each of the next m lines contains two integers u and v, denoting a railway between towns u and v (1 ≤ u, v ≤ n, u ≠ v).

You may assume that there is at most one railway connecting any two towns.

Output

Output one integer — the smallest possible time of the later vehicle's arrival in town n. If it's impossible for at least one of the vehicles to reach town n, output  - 1.

Examples

input

4 21 33 4

output

2

input

4 61 21 31 42 32 43 4

output

-1

input

5 54 23 54 55 11 2

output

3

Note

In the first sample, the train can take the route

and the bus can take the route

. Note that they can arrive at town 4

In the second sample, Absurdistan is ruled by railwaymen. There are no roads, so there's no way for the bus to reach town 4.

题意:有n个城镇,两个城镇之间要么有一条铁路,要么有一条公路,通过一条铁路和一条公路的时间均为1。有一辆汽车和一辆火车,他们同时从点1出发,要到达点n,中间不会停留。为了避免交通事故,他们不能在同一时刻到达同一个点(除开终点n)。问两辆车都到达n点的最短时间。

题解:如果1到n是铁路相连,那么火车一定走这条路,汽车一定是走最短路。反之亦然。所以判断一下是哪种方式是可以直达的,再求一下另外一种方式的最短路就可以了。

代码:

#pragma comment(linker, "/STACK:102400000,102400000")//#include#include#include#include#include#include#include#include#include#include#include#include#include using namespace std;typedef long long ll;typedef unsigned long long ull;#define mst(a) memset(a, 0, sizeof(a))#define M_P(x,y) make_pair(x,y) #define rep(i,j,k) for (int i = j; i <= k; i++) #define per(i,j,k) for (int i = j; i >= k; i--) #define lson x << 1, l, mid #define rson x << 1 | 1, mid + 1, r const int lowbit(int x) { return x&-x; } const double eps = 1e-8; const int INF = 1e9+7; const ll inf =(1LL<<62) ;const int MOD = 1e9 + 7; const ll mod = (1LL<<32);const int N = 3e5+7; const int M=100010;const int maxn=2e3+7; template inline void getmax(T1 &a, T2 b) {if (b>a)a = b;} template inline void getmin(T1 &a, T2 b) {if (b map[v][j] + res[v]) //check { res[j] = map[v][j] +res[v]; } } } if (res[n] == INF) //如果最后的值没有改变 说明不可能 { puts("-1"); return ; } else cout<

版权声明:本文内容由网络用户投稿,版权归原作者所有,本站不拥有其著作权,亦不承担相应法律责任。如果您发现本站中有涉嫌抄袭或描述失实的内容,请联系我们jiasou666@gmail.com 处理,核实后本网站将在24小时内删除侵权内容。

上一篇:解决偶现的MissingServletRequestParameterException异常问题
下一篇:Codeforces Round #344 (Div. 2) C. Report (脑洞题)
相关文章

 发表评论

暂时没有评论,来抢沙发吧~